#!/usr/bin/perl -T
#!/usr/local/bin/perl -T

## --> RF Pi Network Designer, pinet.cgi
## --> Green Bay Professional Packet Radio, www.gbppr.org

## This file Copyright 2000 <contact@gbppr.org> under the GPL
## NO WARRANTY. Please send bug reports / patches / reports.

# Setup
#
use Math::Complex;
select STDOUT;
$| = 1;
$pic = "pics/pinet.png";

# Print MIME
#
print "Content-type:text/html\n\n";

# Read environment
#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

my $rs = $FORM{'rs'};

my $rl = $FORM{'rl'};

my $q = $FORM{'q'};

my $frq = $FORM{'frq'};
my $frq_val = $FORM{'frq_val'};

# Clean up user input data
#
$rs =~ tr/0-9.//csd;

if (!$rs) {
  $rs = 50; # 50 ohms
}

$rl =~ tr/0-9.//csd;

if (!$rl) {
  $rl = 300; # 300 ohms
} 

$q =~ tr/0-9.//csd;

if (!$q) {
  $q = 4; # low Q
} 

$frq =~ tr/0-9.//csd;

if (!$frq) {
  $frq = 10; $frq_val = "MHz"; # 10 MHz
}

# Start calculations
#

# Frequncy
#
if ($frq_val eq "kHz") {
  $frq = $frq / 1000; # kHz to MHz
}

# Start calculations
#
$xc1 = $rs / $q; 
$a = ($rs / $rl) / ((($q ** 2) + 1) - ($rs / $rl));
$xc2 = $rl * (sqrt $a);
$xl = (($q * $rs) + (($rs * $rl) / $xc2)) / (($q ** 2) + 1);

$C1 = 1 / (2 * pi * $frq * $xc1);
$C2 = 1 / (2 * pi * $frq * $xc2);
$L1 = $xl / (2 * pi * $frq);


# Make all pretty
#
$q = sprintf "%.3f", $q;
$rs = sprintf "%.3f", $rs;
$rl = sprintf "%.3f", $rl;

$frq = sprintf "%s", $frq;

$l1uh = sprintf "%.4f", $L1;
$l1nh = sprintf "%.3f", $L1 * 1000;

$c1uf = sprintf "%.4f", $C1;
$c1pf = sprintf "%.3f", $C1 * 1000000;

$c2uf = sprintf "%.4f", $C2;
$c2pf = sprintf "%.3f", $C2 * 1000000;

$date = scalar gmtime;

# Draw me a web page
#
$b = "<font color=\"blue\">";
$p = "<font color=\"purple\">";
$e = "</font>";

print <<EOF;
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<title>RF Pi Network Designer Results</title>
</head>
<body bgcolor="#D3D3D3" text="#000000" link="blue">
<center>
<h2>RF Pi Network Designer Results</h2>
</center>

<hr noshade>
<center><img src="$pic" alt="[pinet]"></center>

<pre>
   $b Source impedance : $e$rs$b ohms $e
     $b Load impedance : $e$rl$b ohms $e
$b Operating frequency : $e$frq$b MHz $e
<br>
          $p Circuit Q : $e$q

                 $p L1 : $e$l1uh$p &micro;H $e
		    $p : $e$l1nh$p nH $e

                 $p C1 : $e$c1uf$p &micro;F $e
		    $p : $e$c1pf$p pF $e

                 $p C2 : $e$c2uf$p &micro;F $e
                    $p : $e$c2pf$p pF $e
</pre>

<hr noshade size="5">

<p><font size="-1">Calculated on $date GMT</font></p>

</body>
</html>
EOF
